var request = null;
var timeout = null;
var timeoutDelay = 4000;
var responseIdx = 0;

function gpio_init() {
	//console.log("gpio_init()");
	gpio_connect();
}

function gpio_connect() {
	//console.log("gpio_connect()");
	url = "/cgi-bin/nph-cgi_lwc?cmd=ADD%20GPI%0AADD%20GPO&live=1&keep-alive=30&sid=" + new Date().getTime();

	request && request.abort();
	request = new XMLHttpRequest();
	request.open("GET", url, true);
	request.onprogress = gpio_progress;
	request.send(null);

	responseIdx = 0;
	if (!timeout) {
		timeout = setTimeout(gpio_timeout, 60000);
	}
}

function gpio_progress() {
	//console.log("gpio_progress(" + request.readyState + ")");
	if (request.readyState != 3) {
		return;
	}

	timeoutDelay = 4000;
	clearTimeout(timeout);
	timeout = setTimeout(gpio_timeout, 60000);

	var response = request.responseText.substring(responseIdx);
	if (!response) {
		return;
	}
	responseIdx += response.lastIndexOf('\n') + 1;

	var lines = response.split('\n');
	for (var i=0; i < lines.length-1; i++) {
		gpio_update(lines[i]);
	}
}

function gpio_update(line) {
	//console.log("gpio_update(" + line + ")");
	if (line.charAt(0) == 'G') {
		var tag = /(GP[IO][ ]\d[ ])[HhLl]/;
		var result = tag.exec(line);
		var pattern = /(?:GP[IO][ ]\d[ ])([HhLl]+)/;
		var data = pattern.exec(line);
		for (j = 0; j < 5; j++) {
			id = document.getElementById(result[1] + j);
			state = data[1].charAt(j);
			if (id != null) {
				if (state == 'L' || state == 'l')
					id.className = "gpio_active";
				else
					id.className = "gpio_out";
			}
		}
	}
}

function gpio_timeout() {
	//console.log("gpio_timeout()");
	request.abort();
	if (timeoutDelay > 30000)
		timeoutDelay = 30000;
	timeout = setTimeout(gpio_timeout, timeoutDelay);
	gpio_connect();
	timeoutDelay *= 2;
}

var g_e=null,g_t=null;
function srcsel(e,t) {
	g_e=e; g_t=t;
	msgWindow=window.open("/cgi-bin/cgi_srclist","displayWindow", "toolbar=no,scrollbars=yes,left=200,top=110,height=400,width=350");
	return false;
}

function srcset(url,lwtype) {
	if(g_e!=null) g_e.value=url;
}

// Version of srcset() that uses AJAX rather than "Apply"
// Doesn't work
/*
function srcset(url, lwtype) {
	if(g_e!=null) g_e.value=url;
	if(g_t!=null) {
		if (g_t.type == "hidden") {
			g_t.value = lwtype;
		}
		else {
			g_t.selectedIndex=g_t.options.length-1;
			for(i=0;i<g_t.options.length;i++) if(g_t.options[i].value==lwtype) g_t.selectedIndex=i;
		}
	}

	var r=null;
	try {
		r=new XMLHttpRequest();
	}
	catch(e) {}
	if(!r) {
		try {
			r=new ActiveXObject("Microsoft.XMLHTTP");
		}
		catch(e) {}
	}
	if(!r) return;

	var DSTflag = -1;
	var ip = new Array();
	var pattern = /(\d+)\s/;
	var chan = pattern.exec(g_e.value);
	var channel = parseInt(chan[0]);
	pattern = /\s([^.]+)/;
	var addr = pattern.exec(g_e.value);

	var url = "/cgi-bin/nph-cgi_lwc";
	var cmd;
	if(g_e.name.substr(0,1) == 'R') {
		DSTflag = 1;
		port = parseInt(g_e.name.substr(3,4)) + 1;
		ipall = channel + lwtype;
		for (i=0; i < 4; i++) {
			ip[i] = ipall & 0xFF;
			ipall >>= 8;
		}
		cmd = "DST " + port + " ADDR:\"" + ip[3] + "." + ip[2] + "." + ip[1] + "." + ip[0] + addr[0] + "\" ";
	}
	else {
		port = parseInt(g_e.name.substr(5,6)) + 1;
		cmd = "CFG GPO " + port + " SRCA:\"" + channel + addr[0] + "\" ";
	}

	if (!cmd) return;
	url += "?cmd=" + escape(cmd);

	try {
		r.open("GET", url, false);
		r.send(null);
	}
	catch(e) {}

	if (DSTflag != -1)
		e = document.getElementById("DSTsuccess");
	else
		e = document.getElementById("GPOsuccess");

	if(r.status == 200) {
		e.className = "success";
		e.innerHTML = "Route Change Successful.";
	}
	else {
		e.className = "failure";
		e.innerHTML = "Route Change Failed.";
	}
	console.log("-- set timeout");
	setTimeout("clearMsg()", 5000);
	console.log("-- done");
}

function clearMsg() {
	e = document.getElementById("DSTsuccess");
	if(e) e.innerHTML = "";
	e = document.getElementById("GPOsuccess");
	if(e) e.innerHTML = "";
}
*/
